$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2011-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$   ܥեȥѤΤޤࡥʲƱˤѡʣ
$   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$       ˴ޤޤƤ뤳ȡ
$   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$       ѤǤǺۤˤϡۤȼɥȡ
$       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$       ̵ݾڵǺܤ뤳ȡ
$   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$       ѤǤʤǺۤˤϡΤ줫ξ
$       ȡ
$     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$         𤹤뤳ȡ
$   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$       դ뤳ȡ
$  
$   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$   TOPPERSץȤϡܥեȥ˴ؤơλŪ
$   ФŬޤơʤݾڤԤʤޤܥեȥ
$   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$   Ǥʤ
$
$   $Id: kernel_lib.tf 1003 2014-04-23 11:58:48Z ertl-hiro $
$  
$ =====================================================================

$ =====================================================================
$  ꥪ֥ȤƬΥɥ쥹μФ
$ =====================================================================

$IF !ISFUNCTION("START_SYMBOL")$
$FUNCTION START_SYMBOL$
	$RESULT = SYMBOL(CONCAT("__start_", ARGV[1]))$
$END$
$END$

$IF !ISFUNCTION("LIMIT_SYMBOL")$
$FUNCTION LIMIT_SYMBOL$
	$RESULT = SYMBOL(CONCAT("__limit_", ARGV[1]))$
$END$
$END$

$ =====================================================================
$  ǡLMAVMAؤΥԡ
$ =====================================================================

$FUNCTION COPY_LMA$
	$FOREACH lma LMA.ORDER_LIST$
		$start_data = SYMBOL(LMA.START_DATA[lma])$
		$end_data = SYMBOL(LMA.END_DATA[lma])$
		$start_idata = SYMBOL(LMA.START_IDATA[lma])$
		$IF !LENGTH(start_data)$
			$ERROR$
				$FORMAT(_("symbol '%1%' not found"), LMA.START_DATA[lma])$
			$END$
		$ELIF !LENGTH(end_data)$
			$ERROR$
				$FORMAT(_("symbol '%1%' not found"), LMA.END_DATA[lma])$
			$END$
		$ELIF !LENGTH(start_idata)$
			$ERROR$
				$FORMAT(_("symbol '%1%' not found"), LMA.START_IDATA[lma])$
			$END$
		$ELSE$
			$BCOPY(start_idata, start_data, end_data - start_data)$
		$END$
	$END$
$END$

$ =====================================================================
$ kernel_cfg.ckernel_mem.cζʬ
$ =====================================================================

$FUNCTION GENERATE_CFILE_HEADER$
	#include "kernel/kernel_int.h"$NL$
	#include "kernel_cfg.h"$NL$
	$NL$
	#if TKERNEL_PRID != 0x06u$NL$
	#error "The kernel does not match this configuration file."$NL$
	#endif$NL$
	$NL$

	/*$NL$
	$SPC$*  Include Directives (#include)$NL$
	$SPC$*/$NL$
	$NL$
	$INCLUDES$
	$NL$
$END$

$ =====================================================================
$ ݸɥᥤ
$ =====================================================================

$FUNCTION GENERATE_DOMINIB$
	/*$NL$
	$SPC$*  Protection Domain Management Functions$NL$
	$SPC$*/$NL$
	$NL$

$	// ݸɥᥤIDֹκ
	const ID _kernel_tmax_domid = (TMIN_DOMID + TNUM_DOMID - 1);$NL$
	$NL$

$	// ݸɥᥤƥȥ֥åΤ
	$IF ISFUNCTION("PREPARE_DOMINICTXB")$
		$PREPARE_DOMINICTXB()$
	$END$

$	// ͥɥᥤݸɥᥤ֥å
	const DOMINIB _kernel_dominib_kernel = { TACP_KERNEL
	, INT_PRIORITY(TMIN_TPRI)
	$IF USE_DOMINICTXB$
		, $DOMINICTXB_KERNEL$
	$END$
	$SPC$};$NL$
	$NL$

$	// ݸɥᥤ֥å
	$IF LENGTH(DOM.ID_LIST)$
		const DOMINIB _kernel_dominib_table[TNUM_DOMID] = {$NL$
		$JOINEACH domid DOM.ID_LIST ",\n"$
			$TAB${ TACP($domid$)
			, INT_PRIORITY($ALT(MINPRIORITY[domid], "TMIN_TPRI + 1")$)
			$IF USE_DOMINICTXB$
				, $GENERATE_DOMINICTXB(domid)$
			$END$
			$SPC$}
		$END$$NL$
		};$NL$
	$ELSE$
		TOPPERS_EMPTY_LABEL(const DOMINIB, _kernel_dominib_table);$NL$
	$END$$NL$
$END$
